/*-----------------------------------------------------------------------------
 * CS 155 - Computer & Network Security - Spring 2004
 *
 * file:  inject.h
 * Contact: pkpatel@cs.stanford.edu
 *          mrubens@stanford.edu
 *
 * Description:
 * Headers for the RLOGIN packet sniffing & packet injection attack
 *
 *---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

/* 
 * Pcap/Libnet headers 
 */
#include <libnet.h>
#include <pcap.h>

/*
 *  Networking headers 
 */
#include <sys/socket.h>
#include <net/ethernet.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <arpa/inet.h>

/* 
 * Declare our egg - touch sunetid 
 * \r\n = newline character
 */
#define EGG "\r\ntouch binky\r\n"

/*
 * Spoof data - to be collected...
 * - these are only hints - you might need more or less!
 */
struct spoof_info
{
  /* Ethernet level */
  u_char        *srcenet;       /* 6 bytes - clientcow */
  u_char        *dstenet;       /* 6 bytes - servercow */
  
  /* IP level */
  u_int8_t      iptos;          /* Type of Service */
  u_short 	ipid;	       	/* Packet id - 
			       	 * increases monotonically */
  u_short 	ipoff;	       	/* Flags */
  u_int32_t 	srcip;	       	/* clientcow IP addr */
  u_int32_t	dstip;	       	/* servercow IP addr */
 
  /* TCP level */
  u_int32_t 	seq;   		/* Sequence number of the first
		       		 * byte of our EGG */
  u_int32_t	ack;   		/* Acknowledgement number */
  u_int16_t 	window;		/* Window size */
  u_short 	srcprt;		/* Src Port - clientcow */
  u_short       dstprt;		/* Dst Port - servercow */
  u_char        *options;      	/* Options fields */
};

int capture();
void inject_packet(struct spoof_info *spoof_data);
